/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;

public class Result 
{    
private Collection Results=null;
private error Error;
private boolean Status = true;
private Iterator It = null;
public result_body NextResult = null;
private int num = 0;

  public Result(error _Error, Collection _Results) 
  {
    Reset();  
    if (_Error!=null) Error=_Error;
    if (_Results!=null) Results=_Results;
     else
     {
      Error.setMes("Result: no results");
      Results=null;
      Status=false;
     }    
    //Error.setMes("Result "+Status);
  }
    
  public boolean HasNext()
  {
    if (!Status) return false;
    else
    {
      if (It==null) It = Results.iterator();
      return It.hasNext();
    }
  }
  
  public boolean getNextResult()
  {
   if (!Status) return false;   
   if (It==null) HasNext();
   Object O = It.next();   
   if (O==null) return false;
   result_body RB = (result_body)O;
   NextResult = RB;
   num++;
   return true;
  }
  
  public boolean getStatus()
  { 
    return Status;  
  }
  
  public void setStartNum(int N)
  {
    if (N<=0) num=0;
     else num=N;
  }
  
  public int getCurrentNum()
  {
   return num;   
  }
  
  public void Reset()
  {
    It=null;
    NextResult = null;
    Status=true;
    num=0;
  }
}
