/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;
 

public class constants  
{
  public static final int NO_ERROR = 0; 
  public static final int EMPTY_QUERY = 1;  
  public static final int NO_DB_CONNECT = 2;  
  public static final int INTERNAL_DB_ERROR = 3;
  public static final int QUERY_BAD_FORMAT = 4;
  public static final int INTERNAL_PROGRAMM_ERROR = 5;
  public static final int KILLER_DOWN = 6; 
  public static final int INSERTION_ERROR = 7;
  
  public static final int TERM = 0;
  public static final int NOT_TERM = 1;  
  public static final int WILDCARD = 2;
  public static final int RBRACKET = 3;  
  public static final int LBRACKET = 4;
  public static final int AND = 5;
  public static final int OR = 6; 
  public static final int DOMAIN = 7;
  public static final int CLASS = 8; 
  public static final int NOT_DOMAIN = 9; 
  public static final int NOT_WILDCARD = 10; 
  
  public static final String DEFAULT_CLASS="ALL";
  public static final int RESULTS_PRO_PAGE = 10;
  public static final int MAX_RES_NUM = 2000;
  public static final int URL_RES_LEN = 50;
  public static final long SESSION_TIMEOUT = 60000;
  
  public static final String TERM_T = "SEEV_ORIGIN";
  public static final String FEATURE_T = "SEEV_FEATURE";
  public static final String DOC_T="SEEV_DOCUMENTS";
  public static final String ARCHDOC_T ="archivedocuments";
  public static final String CLASS_T ="classes";
  public static final String TEMP_USER = "SEEV_temp_user";
  public static final String HISTORY_T = "SEEV_history_temp_user";
  
  //ordering scheme

  public static final String DEFAULT_ORDER = "by AUTO rank";
  public static final String AUTH_ORDER = "by Authority rank";
  public static final String HUB_ORDER  = "by Hub rank";
  public static final String TFIDF_ORDER  = "by TF_IDF rank";
  public static final String DATE_ORDER = "by date (newerest)";

/*  
  public static final String DEFAULT_ORDER = "0";
  public static final String AUTH_ORDER = "1";
  public static final String HUB_ORDER  = "2";
  public static final String TFIDF_ORDER  = "3";
  public static final String DATE_ORDER = "4";
  */ 
  public static final String IDSTR_PREFIX = "id";  
  public static final String DEFAULT_TITLE = "NO TITLE";
  public static final String BASE_ADRESS = "index.jsp";
  public static final String LOG_PATH = "..\\..\\eskelog.txt";
  public static final String ACCOUNT_PATH = "..\\..\\account.dat";

/*  
  public static String host = "havana.cs.uni-sb.de";
  public static String service = "gov";
  public static String login = "bingo";
  public static String pass = "Q";
*/

  public static session_killer S_K;

  private Vector ORDERS = new Vector();  
  
  public constants() 
  {
    ORDERS.add(DEFAULT_ORDER);
    ORDERS.add(AUTH_ORDER); 
    ORDERS.add(HUB_ORDER); 
    ORDERS.add(TFIDF_ORDER); 
    ORDERS.add(DATE_ORDER);   
  }
  
  public Vector getOrders()
  {
    return ORDERS;  
  }
  
  public static void get_killer()
  {
   if (S_K==null || !S_K.getStatus()) 
    {
     S_K = new session_killer();
     new Thread(S_K).start();
    }
  }
  
  public String getIDStr(long _ID)
  {
    return IDSTR_PREFIX+_ID;  
  }
  
/*  
  public void readAccounts() 
    {
     java.net.URL u = this.getClass().getClassLoader().getResource( "ACCOUNT_PATH" );

     try 
     {
      java.io.BufferedReader bf = new java.io.BufferedReader( new InputStreamReader( u.openStream() ) );
      String line = bf.readLine();

      while ( line != null ) {
        StringTokenizer st = new StringTokenizer( line, ";" );
        login = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "" ) ).trim();
        pass = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "" ) ).trim();
        host = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "-" ) ).trim();
        service = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "-" ) ).trim();
        line = bf.readLine();
      }
      bf.close();
     }
     catch ( Exception e ) 
     {;}
   }
*/  
}
