/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;

public class query_parser 
{
 private error Error;
 private String Regex=" []()|";
 private boolean TmFt;
    
 public query_parser(error _Error) 
 {
   if (_Error!=null) Error=_Error;
   else {;}
 }
 
 public void setTmFt(boolean _TmFt)
 {
   TmFt=_TmFt;
 }
 
 private Collection split(String Str, String Regex)
 {
  Vector res= new Vector();   
  char[] Ch = Regex.toCharArray();
  String temp=new String();
  temp=Str;
  int len = 0;
  while (temp.length()>0)
   {  
      int min = temp.length();
      int minR = -1;
      for (int i = 0; i<Ch.length; i++)
        if (temp.indexOf(Ch[i])>=0&&temp.indexOf(Ch[i])<min)
         {min = temp.indexOf(Ch[i]); minR = i;}
      if (minR==-1) {res.add(temp); temp=""; len++;}
       else 
        {
          if (min==0) {res.add(temp.substring(min,min+1)); len++; temp=temp.substring(min+1,temp.length());}
           else
           if (min==temp.length()-1) {res.add(temp.substring(0,min)); len++; res.add(temp.substring(min,min+1)); temp=""; len++;}
            else
             {res.add(temp.substring(0,min)); len++; res.add(temp.substring(min,min+1)); len++; temp=temp.substring(min+1,temp.length());}   
                
        }
   }
  return res;
 }
 
 public Vector parse(String _query)
 {
  Vector V = new Vector();   
  if (_query=="") {Error.setErr(constants.QUERY_BAD_FORMAT); return null;}
  if (Security_test(_query))
   {   
    Vector termsV = (Vector)split(_query, Regex);
    /*
     log = -1 (logical term) log = +1 (term)
     br= sum of brackets lbracket = -1 rbracket = +1 
     */
    int br=0;
    int type = -1;
    int prevtype = -1;
    for (int i=0, log=0;  i<termsV.size(); i++)
     {
       String terms = (String)termsV.elementAt(i);  
       query_body QB = new query_body(terms, TmFt);
       type = QB.getTYPE();
       if (!terms.equals(" "))
        {
          switch (type)
          {
              case constants.LBRACKET: 
               {
                if (log==1 || prevtype == constants.RBRACKET)
                  {query_body LQB = new query_body(" ", TmFt);  V.add(LQB); }                    
                log=-1; br--;
                } break;
              case constants.RBRACKET: 
              {
                if (prevtype == constants.OR || prevtype == constants.AND || prevtype == constants.LBRACKET)
                 {Error.setErr(constants.QUERY_BAD_FORMAT); return null;}
                log=-1; br++;
              } break; 
              case constants.AND:  
               {
                if (prevtype == constants.OR || prevtype == constants.AND || prevtype == constants.LBRACKET)
                 {Error.setErr(constants.QUERY_BAD_FORMAT); return null;}   
                log=-1;
               } break;  
              case constants.OR: 
              {
               if (prevtype == constants.OR || prevtype == constants.AND || prevtype == constants.LBRACKET)
                 {Error.setErr(constants.QUERY_BAD_FORMAT); return null;}    
               log=-1;
              } break;
              default:  
               {
                 if (log==1 || prevtype == constants.RBRACKET)
                  {query_body LQB = new query_body(" ", TmFt);  V.add(LQB); }
                log=1;
               } 
          }            
        V.add(QB); 
        prevtype = QB.getTYPE();
        } 
     }
    if (br!=0) {Error.setErr(constants.QUERY_BAD_FORMAT); return null;} 
   }
  else {;}
  return V;   
 }
    
 private boolean Security_test(String _query)
 {
   return true;  
 }

}
