/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;

public class result_body 
{
 private String title=null;
 private String URL=null;
 private String Description=null; 
 private String ClassName = null;
 private error Error;
 private Date LastDate = new Date();
 private double size; 
 private long ID=0;
 private long GID=0;
 private boolean status = true;  
 
 public result_body(String _url, String _title, String _Desc, double _size, String _Class, long _ID, Date _LastDate, error _Error, long _GID) 
  {
    status = true;  
    if (_Error!=null) Error=_Error;  
     else status = false;
    
    if (_url!="") {URL=_url;}
     else 
     {
      Error.setMes("result: no URL");
      status = false;
     }
    
    if (_title!="") {title=_title;}
     else 
     {
      Error.setMes("result: no Title");   
     } 
    
    if (_ID!=0) ID=_ID;
     else
     {
      Error.setMes("result: no ID");   
      status=false;   
     }

    if (_GID!=0) GID=_GID;
     else
     {
      Error.setMes("result: no GID");   
      status=false;   
     }
    
    if (_Desc!="")
     {
       Description = _Desc;  
     }
     else   
     {
      Error.setMes("result: no Desription");   
     } 
     
    if (_size>0) size=_size;
      else size=0.1;
    
    if (_Class!="")
     {
       ClassName = _Class;  
     }
     else   
     {
      Error.setMes("result: no Class");   
     } 
    
    if (_LastDate!=null) LastDate=_LastDate;
     else LastDate= new Date();
  }

 public boolean getStatus()
 {
  return status;   
 }
 
 public String getTitle()
 {
   return title;  
 }
 
 public String getURL()
 {
   String temp = URL;
   //if (URL.length()>constants.URL_RES_LEN) temp = URL.substring(0,constants.URL_RES_LEN);
   return temp;  
 }
 
 
 
 public String getDesc()
 {
  return Description;   
 }
 
 public String getClassName()
 {
   return ClassName;  
 }
 
 public double getSize()
 {
   return size;  
 }
 
 public String getDate()
 {
   return LastDate.toGMTString();
 }  
 
 public String getSimLink()
 {
   String temp=constants.BASE_ADRESS+"?SIM=SIM&IDD="+ID+"&ID="+GID;
   return temp;
 }
 
 public String getNeighborLink()
 {
  String temp=constants.BASE_ADRESS+"?NEIGHBOR=YES&IDD="+ID;
  
  return temp;
 }
}
