/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

public class search_result 
{
 private String title=null;
 private String URL=null;
 private String Description=null; 
 private error Error;
 private boolean status = true; 
 
 public search_result(String _url, String _title, String _Desc, error _Error) 
  {
    status = true;  
    if (_Error!=null) Error=_Error;  
     else status = false;
    
    if (_url!="") {URL=_url;}
     else 
     {
      Error.setMes("result: no URL");
      status = false;
     }
    
    if (_title!="") {title=_title;}
     else 
     {
      Error.setMes("result: no Title");   
     } 
    
    if (_Desc!="")
     {
       Description = _Desc;  
     }
     else   
     {
      Error.setMes("result: no Desription");   
     } 
        
  }

 public boolean getStatus()
 {
  return status;   
 }
 
 public String getTitle()
 {
   return title;  
 }
 
 public String getURL()
 {
   return URL;  
 }
 
 public String getDesc()
 {
  return Description;   
 }
}
