package search;

import java.io.*;
import java.lang.*;
import java.util.*;

public class Debugger 
{
 private FileOutputStream File;
 private DataOutputStream writer;
 private String filename = new String();
 private boolean error_status = false;
 
 public Debugger(String _filename) 
 {
  if (_filename!=null)   
  try
   { 
    File = new FileOutputStream(_filename,true);
    File.close();
    filename=_filename;
   }
   catch(IOException e)
   {
     error_status = true;
   }  
 }

 public synchronized boolean put(String message)
 {
   if (error_status) return false;
   try
   { 
     File = new FileOutputStream(filename,true);
     writer = new DataOutputStream(File);
     Date d = new Date();
     writer.writeBytes(d.toString()+">>"+message+"\n");
     writer.close();
     File.close();
   }   
   catch (Exception e)
   {
    error_status = true;   
    return false;
   }
   return true;
 }
 
 public boolean getErrorStatus()
 {
   return error_status;  
 }
    
}
