/*
 * NormalDistribution.java
 *
 * Created on 22. August 2003, 11:43
 */

package org.unisb.dbs.stats.distribution;

import org.unisb.dbs.stats.estimators.*;
import java.util.*;

/**
 *
 * @author  T
 */
public class DiscreteDistribution extends AbstractDistribution {
   
  public DiscreteDistribution() {
    super();
  }
  
  public DiscreteDistribution( Set observations ) {
    super( observations );
  }
   
  public DiscreteDistribution( Collection observations ) {
    super( observations );
  }
  
  public Estimator getEstimator() {
    Set observations = observations();
    Estimator e = new DiscreteEstimator( observations.size(), false );
    for ( Iterator i = observations.iterator(); i.hasNext(); ) {
      Observation o = (Observation)i.next();
      e.addValue( o.getData(), o.getWeight() );
    }
    return e;
  }
  
}