/*
 * NormalDistribution.java
 *
 * Created on 22. August 2003, 11:43
 */

package org.unisb.dbs.stats.distribution;

import org.unisb.dbs.stats.estimators.*;
import java.util.*;

/**
 *
 * @author  T
 */
public class NormalDistribution extends AbstractDistribution {
   
  public NormalDistribution() {
    super();
  }
  
  public NormalDistribution( Set observations ) {
    super( observations );
  }
    
  public NormalDistribution( Collection observations ) {
    super( observations );
  }
  
  public Estimator getEstimator() {
    Estimator e = new NormalEstimator( 12 );
    for ( Iterator i = observations().iterator(); i.hasNext(); ) {
      Observation o = (Observation)i.next();
      e.addValue( o.getData(), o.getWeight() );
    }
    return e;
  }

}
