package search;
import java.util.*;
import java.lang.*;


public class Scoring_Function extends Error
{
    private Query query;
    private double[] profile;
    private int NF = 0;
    private Result_List unit_list;
    public static final int default_value = 1; 
    
    public Scoring_Function(Query _query) 
    {
     if (_query == null || query.get_error_status()) set_error_status();
      query = _query;
      NF = query.get_NF();
      
      //here we get a unit result list
      unit_list = new Result_List(null);
      unit_list.create_hash_list();
    }
    
    
    public Result_List get(Query _query, double[] _profile)
    {
      if (get_error_status() || _profile == null || _profile.length != NF) return null;
      profile = _profile;
      Result_List profile_list = unit_list;
      profile_list.set_profile(_profile);
      
      return profile_list;
    }
    
}
