package search;

import java.util.*;
import java.lang.*;

import cern.colt.matrix.linalg.*;
import cern.colt.matrix.*;
import cern.colt.matrix.impl.*;

import weka.core.*;
import weka.clusterers.*;
import weka.filters.unsupervised.attribute.*;

public class test_2 {

    public test_2() 
    {
    }
    
    public static void main(String[] args) 
    { 
      Error err = new Error();  
      double[] A1 = {0.5, 0.3};  
      double[] A2 = {0.3, 0.6}; 
      double[] A3 = {0.2, 0.6};
      double[] A4 = {0.1, 0.3};
      Result_Document[] R_D = {new Result_Document(1, A1), new Result_Document(2, A2), new Result_Document(3, A3), new Result_Document(4, A4)};
      for (int i=0; i<R_D.length; i++)
       R_D[i].setNF(2); 
      Result_List R_L = new Result_List(R_D);
      for (int i=0; i<R_L.getLength(); i++) err.set_error_message("i"+i+" doc "+R_L.get_doc(i).get_doc_id_longValue());          
      Feedback_Document[] F_D = {new Feedback_Document(1, -1), new Feedback_Document(2, 1)};
      Feedback F = new Feedback(F_D);
      
      /*
      Linear_Regression P_R = new Linear_Regression(R_L, F);
      P_R.set_NF(2);
      double[] p_p = P_R.computeProfile();
      Natural_Score_Approach NSP = new Natural_Score_Approach(R_L, F);
      NSP.set_NF(2);
      double[] p=NSP.computeProfile();
      R_L.set_profile(p);
      for (int i=0; i<R_L.getLength(); i++) err.set_error_message("i"+i+" doc "+R_L.get_doc(i).get_doc_id_longValue());          
      P_R.computeProfile();
      //SimpleKMeans C = new SimpleKMeans();
      EM C = new EM();
      FastVector attInfo = new FastVector(100);
      Random R1 = new Random();
      Random R2 = new Random();
      Random R3 = new Random();
      Attribute name = new Attribute("name");      
      Attribute w0 = new Attribute("w0");
      Attribute w1 = new Attribute("w1");
      attInfo.addElement(name);
      attInfo.addElement(w0);
      attInfo.addElement(w1);
      Instances In = new Instances("test", attInfo, 3);
      
      for (int i=0; i<100; i++)
       {
        Instance I1 = new Instance(3);
        Instance I2 = new Instance(3);
        Instance I3 = new Instance(3);
        I1.setValue(0, 1000+i);
        I1.setValue(1,  -0.25 - R1.nextDouble()/2);
        I1.setValue(2,  -0.25 - R1.nextDouble()/2);
        I2.setValue(0, "2000"+i);
        I2.setValue(1,  0.25 + R2.nextDouble()/2);
        I2.setValue(2,  0.25 + R2.nextDouble()/2);
        I3.setValue(0, "3000"+i);
        I3.setValue(1, -0.25 + R3.nextDouble()/2);
        I3.setValue(2, -0.25 + R3.nextDouble()/2);
        In.add(I1);
        In.add(I2);
        In.add(I3);
      }
      System.out.println("All instances >>");
      System.out.println(In);
      In.setClass(w0);
      In.setClass(w1);
      try 
      {
      C.setMinStdDev(0.1);
      AddCluster AC = new AddCluster();      
      AC.setClusterer(C);
      AC.setIgnoredAttributeIndices("first");
      C = (EM)AC.getClusterer();
      ClusterEvaluation CE = new ClusterEvaluation();
      CE.setClusterer(C);
      //CE.evaluateClusterer(In);
      C.buildClusterer(In);
      double[][][] t = C.getClusterModelsNumericAtts();
      double[] d = CE.getClusterAssignments();
      err.set_error_message("# of clusters >>"+C.numberOfClusters());
      err.set_error_message("clusterer "+C.toString());
      err.set_error_message(In.firstInstance().toString());
       */
      try      
      {
        Global_Profiles_Constructor GPC = new Global_Profiles_Constructor();
        GPC.Cluster();
      }
      catch (Exception e)
      {
        e.printStackTrace();  
      }
    }
    
} 
