/*
 * MimeType.java
 *
 * Created on 21. August 2002, 13:26
 */

package bingo.util;

/**
 *
 * @author  T
 */
public class MimeType {
  
  private int maxSize = 400000;
  private boolean allowed = true;
  private String description;
  private String extension;
  
  protected MimeType() {
  }
  
  public MimeType( String x, String d ) {
    this.extension = x;
    this.description = d;
  }

  public MimeType( String x, String d, boolean b, int s ) {
    this.extension = x;
    this.description = d;
    this.allowed = b;
    this.maxSize = s;
  }
  
  public void setAllowed( boolean b ) {
    this.allowed = b;
  }
  
  public void setMaxSize( int s ) {
    this.maxSize = s;
  }
  
  public String getDescription() {
    return description;
  }

  public String getExtension() {
    return extension;
  }
  
  public int getMaxSize() {
    return maxSize;
  }
  
  public boolean isAllowed() {
    return allowed;
  }
    
  public String toString() {
    return description;
  }
}
