/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;


public class session_killer implements Runnable
{
 private error Error;   
 private dbconnect DB;
 private constants C = new constants();
 private debugger Debugger;
 private long ID = 0;
 private boolean status= false;
    
    public session_killer() 
    {
     Date D = new Date();
     ID = D.getTime();
     Debugger = new debugger(constants.LOG_PATH);     
     Error = new error(Debugger);   
     DB = new dbconnect(Error);
     Error.setMes("Killer: I am live "+ID);
    }
    
    public boolean getStatus()
    {
      return status;  
    }
    
    public void run() 
    {
     status=DB.OpenConnect();  
      while (status)
       {
        try
         {
          synchronized (this) {this.wait(C.SESSION_TIMEOUT);}
          Error.setMes("I am still live Killer"+ID);
          if (!DB.deleteSession())
           {
             Error.setErr(C.KILLER_DOWN);
             break;
           }
         }
         catch (Exception e)
         {
          Error.setMes("Killer: "+e.toString());   
          Error.setErr(C.KILLER_DOWN);
          break;
         }
       }
     DB.CloseConnect(); 
     Error.setMes("Killer: I am dead "+ID);    
    }
    
}
