/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.util.*;
import java.lang.*;


public class tester {
private debugger D;
private error Error;
private dbconnect DB;
private Vector terms= new Vector();
private int NT = 1;
private testThread[] TT;
private int SoulCounter = 0;
//private int[] Souls;
    
    public tester() 
    {
       D = new debugger(constants.LOG_PATH);     
       Error = new error(D);   
       DB = new dbconnect(Error);  
    }
    
    public void setNT(int _NT)
    {
      if (_NT<1) NT=1;
       else NT = _NT;
    }
    
    public void StartTest()
    { 
      Error.setMes("Test started at "+new Date().toGMTString());  
      DB.OpenConnect();
      String Query="select distinct(term) as term from "+constants.FEATURE_T+"";
      terms=(Vector)DB.simpleQuery(Query,"term");
      Query="select count(distinct(term)) as num from "+constants.FEATURE_T+"";
      Vector V = (Vector)DB.simpleQuery(Query,"num");
      int N = (new Integer(V.elementAt(0).toString())).intValue();
      Error.setMes("tester: "+terms.size()+" N="+N+" NT="+NT);
      if (N<NT) NT=N;
      if (NT<1) NT=1;
      //for (int i=0; i<NT; i++) Souls[i]=0;
      int por = N/NT;
      TT = new testThread[NT];
      for (int i=0; i<NT; i++)
       {
         V = new Vector();
         int k=0;
         for (int j=0; j<por && i*por+j<N ; j++, k=i*por+j) V.add(terms.elementAt(k));
         TT[i] = new testThread(Error, V);
       } 
      
      for (int i=0; i<NT; i++)
       {
         new Thread(TT[i]).start();  
       }
      
      Error.setMes("Tester I am going to sleep");
      try 
      {
        while (SoulCounter < NT)
         {
           SoulCounter = 0;              
           for (int i=0; i<NT; i++)
            if (TT[i].getStatus()) synchronized (TT[i]) {TT[i].wait();}
             else SoulCounter++; 
         }
      }
      catch (Exception e) 
      {
        Error.setMes("Tester CAN'T WAIT "+SoulCounter+"\n"+e.toString());  
      }
    DB.CloseConnect();  
    Error.setMes("Tester: FINISH");  
    }
    
}
