<%@ page info = "Check von Bingo!" errorPage = "error.jsp"
import="bingo.*, java.util.*" %>

<HTML>
<HEAD>
 <TITLE>Featureselektion: Auswahl der Features</title>
</HEAD>
<BODY bgcolor=white>


<jsp:useBean id="userInfos" scope="application" class="bingo.bingo_feed_userInfos" />
<jsp:useBean id="featuresCheck" scope="session" class="bingo.bingo_features_check" />

<%
    String check = request.getParameter ("check");
    if (check != null && check.trim().length() > 0)
    {
      response.sendRedirect("feature_check.jsp");
      return;
    }

    long classid = 0;
    int mindf = 0;
    String filter = null;    
    int amount = 100;
    String posneg = null;

    if (request.getParameterNames().hasMoreElements()) 
    { 
     classid = Long.parseLong(request.getParameter ("klasse"));
     mindf = Integer.parseInt(request.getParameter ("df"));
     filter = request.getParameter ("filter");
     if (filter == null)
       filter = "";
     if (!filter.equals("pos"))
       posneg = "POS+NEG";
     else
       posneg = "nur POS";
     String amountString = request.getParameter ("amount");
     if (amountString != null && amountString.length()>0)
       amount = Integer.parseInt(amountString);
     else
       amount=100;
     amountString=null;
    } 

    ArrayList result = featuresCheck.getFeaturesForClass(classid, mindf, filter, amount);
    if (result==null)
      result = new ArrayList(0);

    if (result.size() > 0)
    {
%>

<TABLE width=100% border=0>
<TR>
  <TD width=40% align=center valign=middle>
     <IMG SRC="images/feed2.gif" border=0>
  </TD>
  <TD width=60% align=left>

<BR><BR>
<SMALL>
Die Klasse <I><B><%=featuresCheck.className%></B></I>
<UL>
  <LI> Angezeigt sind <%=result.size()%> Features fuer den Filter (DF >= <%=featuresCheck.DF%>, Count <= <%=amount%>, <%=posneg%>)
  <LI> <%=featuresCheck.numFeaturesPositive%> davon sind als positiv markiert
  <LI> Die Klasse hat insgesamt <%=featuresCheck.numFeaturesInsgesamt%> Features, <%=featuresCheck.numFeaturesInsgesamtPositive%> davon als positiv markiert
</UL>
Filter: <A href="feature_auswahl.jsp?amount=<%=amount%>&klasse=<%=classid%>&df=<%=mindf+1%>">DF+1</A> (<%=featuresCheck.countHigherDF%>), 
<A href="feature_auswahl.jsp?amount=<%=amount%>&klasse=<%=classid%>&df=<%=mindf-1%>">DF-1</A> (<%=featuresCheck.countLowerDF%>), 
<A href="feature_auswahl.jsp?amount=<%=Math.min(result.size(), amount)+50%>&klasse=<%=classid%>&df=<%=mindf%>">Anzahl+50</A>,  
<A href="feature_auswahl.jsp?amount=<%=Math.min(result.size(), amount)-50%>&klasse=<%=classid%>&df=<%=mindf%>">Anzahl-50</A>, 
nur <A href="feature_auswahl.jsp?amount=<%=amount%>&klasse=<%=classid%>&df=<%=mindf%>&filter=pos">POS</A> oder 
<A href="feature_auswahl.jsp?amount=<%=amount%>&klasse=<%=classid%>&df=<%=mindf%>&filter=">POS+NEG</A>
<BR><BR>
<IMG src="images/globe.gif" border=0> Beispieldokument mit bestem SVM Score<BR>
<input type="checkbox" name="test" value="test" CHECKED> Gute Features: Checkbox <B>ON</B>, schlechte Features: Checkbox <B>OFF</B><BR>
</SMALL>

  </TD>
</TR>
</TABLE>

<form method="post" action="feature_aktualisieren.jsp">
<Input type="hidden" name="df" value="<%=mindf%>"
<Input type="hidden" name="filter" value="<%=filter%>">
<Input type="hidden" name="amount" value="<%=amount%>">

<center><table width=90%>
<TR><TD><B>Stem (DF)</B></TD><TD><B>Context</B></TD><TD><B>MI Rating</B></TD></TR>
<TR><TD><HR></TD><TD><HR></TD><TD><HR></TD></TR>

<%
     Iterator it = result.iterator();
     int count=0;
     while (it.hasNext())
     {
       TermPreview tp = (TermPreview) it.next();
       count++;
       if (count % 2 == 0)
       {
%>
         <TR bgcolor=lightgrey><TD><input type="checkbox" name="feature<%=count%>" value="<%=tp.term%>"
<%
       }
       else
       {
%>
         <TR bgcolor=white><TD><input type="checkbox" name="feature<%=count%>" value="<%=tp.term%>"
<%
       }

       if (tp.evaluation > 0)
       {
%>     
          checked>
<%
       }
       else
       {
%>     
       >
<%
       }
%>
       <INPUT type="hidden" name="term<%=count%>" value="<%=tp.term%>">
       &nbsp;&nbsp;&nbsp; <%=tp.term%> (<%=tp.df%>)</TD>
<%     
       if (tp.context != null && tp.context.length() > 0)  
       {
%>
        <TD><SMALL>
             &nbsp;
<%      if (tp.bestURL != null && tp.bestURL.length() > 0)
        { 
%>
         <A href="<%=tp.bestURL%>" target=_blank><Img src="images/globe.gif" border=0></A> &nbsp;&nbsp; 
<%
        }
%>

        <%=tp.context%> </SMALL></TD>
<%
       }
       else
       {
%>
        <TD><SMALL>&nbsp;</SMALL></TD>
<%
       }
%>     
       <TD><SMALL><%=tp.score%>% &nbsp;&nbsp;&nbsp; (<%=tp.mi%>)</SMALL></TD></TR>
<%
      }     
%>
</table>

<HR>

<P>
<input type="hidden" name="anzahl" value="<%=result.size()%>">
<input type="hidden" name="klasse" value="<%=classid%>">
<input type="submit" name=rewrite value="Rewrite Result">
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type="submit" name=modify value="Add to Result">
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type="submit" name=on value="all ON">
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type="submit" name=off value="all OFF">
</form>
<BR><BR>
</center>


<%
   }
   else
   {
%> <BR><BR><BR>
<Center>
   <H3> <IMG src="images/warning.gif" border=0> &nbsp;&nbsp; Keine Features fuer gewaehlte Selektion &nbsp;&nbsp; <IMG src="images/warning.gif" border=0> </H3>
<center>
<%
   }
%> 

</body>
</html>