drop table SEEV_FEATURE_CLASS_4;

CREATE TABLE SEEV_FEATURE_CLASS_4
(
    KEY               varchar2(200)  NOT NULL,
    VALUE             number         DEFAULT 0 ,
    DOCID              NUMBER       NOT NULL,
    FOREIGN KEY (DOCID) REFERENCES SEEV_Documents
      ON DELETE CASCADE
);

insert into SEEV_FEATURE_CLASS_4
select TO_CHAR(lastdate) as key, 1 - MONTHS_BETWEEN(lastdate, MN)/MONTHS_BETWEEN(Mx,Mn) as value, docid from 
  seev_documents, 
  (select max(lastdate) as MX, min(lastdate) as MN from seev_documents)
