package search;

import java.io.*;

public class Feedback_Document extends Error implements Serializable
{
    private long DOCID = 0;
    private int status = this.NEUTRAL;
    
    public Feedback_Document(long _DOCID, int _status) 
    {
      DOCID = _DOCID;
      if (_status!=this.POSITIV && _status!=this.NEGATIV) status = NEUTRAL;
      status = _status;
    }
    
    public int getStatus()
    {
      return status;  
    }
    
    public long getDOCID()
    {
      return DOCID;  
    }
    
    public double getDocScore()
    {
      if (status == POSITIV) return 1.0;
      if (status == NEGATIV) return -0.1; 
      return 0.5;
    }
}

