package search;

import java.io.*;

public class Query extends Document implements Serializable
{  
    private String queryStr = null;
    
    public Query(int _NF, String _queryStr) 
    {
      set_NF(_NF);
      setqueryStr(_queryStr);
      for (int i=0; i < _NF; i++)
       if (ISKEY[i]!=isKey(i)) setKey(i);
    } 
    
    public String getqueryStr()
    {
      if (get_error_status()) return null;
      return queryStr;
    }
    
    private void setqueryStr(String _queryStr)
    {
      if (_queryStr == null) set_error_status();
      queryStr = _queryStr;
    }
    
    public void fill_empty_dimesions()
    {
     for (int i = 0; i < get_NF(); i++)
      if (!isKey(i) && getDimSize(i) == 0) put(i, DEFAULT_VALUE);
    }
    
}
