/*
 * NormalDistribution.java
 *
 * Created on 22. August 2003, 11:43
 */

package org.unisb.dbs.stats.distribution;

import org.unisb.dbs.stats.estimators.*;
import java.util.*;

/**
 *
 * @author  T
 */
public class PoissonDistribution extends AbstractDistribution {
   
  public PoissonDistribution() {
    super();
  }
  
  public PoissonDistribution( Set observations ) {
    super( observations );
  }
   
  public PoissonDistribution( Collection observations ) {
    super( observations );
  }
  
  public Estimator getEstimator() {
    Estimator e = new PoissonEstimator();
    for ( Iterator i = observations().iterator(); i.hasNext(); ) {
      Observation o = (Observation)i.next();
      e.addValue( o.getData(), o.getWeight() );
    }
    return e;
  }
    
}
