package search;

import java.lang.*;
import java.util.*;

public class Scroll extends Error
{
private Iterator It1 = null;
private Iterator It2 = null;
private Vector URL = new Vector();
private Vector Desc = new Vector();
private boolean status=false;
private String CurrentUrl = "";
private String CurrentDesc = "";
    
    public Scroll() 
    {
      reset();  
    }
    
    private void reset()
    {
      It1=null;
      It2=null;
      URL  = new Vector();
      Desc = new Vector();
      status=false;
    }
    
    public void create(int Page, int RproP, int N, long sessionID, String _Address)
    { 
     if (_Address==null || _Address=="") status=false; 
     else 
     {
      if (Page<0) Page=0;
      //Error.setMes("Scroll: "+Page+" "+RproP+" "+N+" "+ID+" "+_Address+" "+Page*RproP);   
      if (N<=0 || RproP<=0 || RproP > N || Page*RproP > N) status = false;
       else
       {
         
        String url =  _Address+"&NEXTPAGE="+(Page-1);
        String desc = " PREVIOUS ";
        int from = (Page-1)*RproP+1;; 
        int to = Page*RproP;
        
        URL.add("");
        Desc.add("Results: "+N);
        
        if (Page>0)
         {
           URL.add(url);
           Desc.add(desc);             
         }
        int p = 0;
        for (int i=0; i<N/RproP && i < Page+10 ; i++)
         {
           from = i*RproP+1;
           to = (i+1)*RproP;
           desc = " "+from+" .. "+to+" ";
           url=_Address+"&NEXTPAGE="+i;
           URL.add(url);
           Desc.add(desc);
           p=i;
         }
        p++;
        
        if (to<N)
        {
           from = to+1; 
           to+=RproP;
           if (to>N) to=N;
           desc = " "+from+" .. "+to+" ";
           url=_Address+"&NEXTPAGE="+p;
           URL.add(url);
           Desc.add(desc);            
        }

        if ((Page+1)*RproP < N)
         {
           url =  _Address+"&NEXTPAGE="+(Page+1);
           desc = " NEXT ";              
           URL.add(url);
           Desc.add(desc);             
         }
       It1 = URL.iterator(); 
       It2 = Desc.iterator();
       status=true;
       }
     }
    }

   public boolean getStatus()
   {
     return status;  
   }
   
   public boolean HasNext()
   {
     if (!status) return false;
     if (It1==null || It2==null) return false;
     if (!It1.hasNext() || ! It2.hasNext()) {reset(); return false;}
      CurrentUrl  = It1.next().toString();
      CurrentDesc = It2.next().toString();
      return true;
   }
   
   public String getUrl()
   {
     if (!status) return null;
     return CurrentUrl;
   }

   public String getDesc()
   {
     if (!status) return null;
     return CurrentDesc;
   }

}
