package search;

import java.lang.*;
import java.util.*;


public class Session_Killer extends Error implements Runnable
{
 private DBconnect DB;
 private long ID = 0;
 private boolean status= false;
    
    public Session_Killer() 
    {
     Date D = new Date();
     ID = D.getTime();
     DB = new DBconnect();
     set_error_message("Killer: I am live "+ID);
    }
    
    public boolean getStatus()
    {
      return status;  
    }
    
    public void run() 
    {
     status=DB.OpenConnect();  
      while (status)
       {
        try
         {
          synchronized (this) {this.wait(SESSION_TIMEOUT/2);}
          set_error_message("I am still live Killer"+ID);
          if (!DB.deleteSession())
           {
             set_error(KILLER_DOWN);
             break;
           }
         }
         catch (Exception e)
         {
          set_error_message("Killer: "+e.toString());   
          set_error(KILLER_DOWN);
          break;
         }
       }
     DB.CloseConnect(); 
     set_error_message("Killer: I am dead "+ID);    
    }
    
}
